#include <stdio.h>
#include <string.h>

#define _(x) printf("" #x "\n  "); x
#define _lp(x) _p(x,"%ld")
#define _dp(x) _p(x,"%.3lf")
#define _sp(x) _p(x,"\"%s\"")
#define _p(x,fmt) { \
  unsigned char *__p = (unsigned char*) &x; \
  printf("" #x  ": "); \
  printf("addr: %p | data: ", &x); \
  for (int __i = 0 ; __i != sizeof(x); __i++)  \
    printf(" %02x", __p[__i]); \
  printf(" | "); \
  printf(fmt, x); \
  putchar('\n'); \
}

int main() { 
_(long   a = 12345678912345;)   _lp(a)
_(double b = 12345678912345.9;) _dp(b) 
_(char c[8] = "1234567";) _sp(c)
   
  // Memory-safe, type-safe
_(a = (double) b;) _lp(a) // OK, possible truncation error
_(b = a;) _dp(b) // OK
_(strcpy(c,"7654321");) _sp(c)

  // Memory safe, but not type-safe
_(a = * (long*) &b;)   _lp(a)
_(b = * (double*) &main); _dp(b)
_(strcpy(c, (char*) &a);) _sp(c)  

  return 0;
}
